﻿Public Class FormTestWebService

    Private KtoClient As WebKtoPruefS.KtoPruefClient ' oder ohne "S" wenn keine TLS-Verschlüsselung gewünscht wird (nicht empfohlen)
    Private AdrClient As WebAddressS.AddressClient ' oder ohne "S" wenn keine TLS-Verschlüsselung gewünscht wird (nicht empfohlen)
    Private Adr2Client As WebAddress2S.Address2Client ' oder ohne "S" wenn keine TLS-Verschlüsselung gewünscht wird (nicht empfohlen)
    Private Adr3Client As WebAddress3S.Address3Client ' oder ohne "S" wenn keine TLS-Verschlüsselung gewünscht wird (nicht empfohlen)

    Private Sub FormTestWebService_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        KtoClient = New WebKtoPruefS.KtoPruefClient ' oder ohne "S" wenn keine TLS-Verschlüsselung gewünscht wird (nicht empfohlen)
        AdrClient = New WebAddressS.AddressClient ' oder ohne "S" wenn keine TLS-Verschlüsselung gewünscht wird (nicht empfohlen)
        Adr2Client = New WebAddress2S.Address2Client ' oder ohne "S" wenn keine TLS-Verschlüsselung gewünscht wird (nicht empfohlen)
        Adr3Client = New WebAddress3S.Address3Client ' oder ohne "S" wenn keine TLS-Verschlüsselung gewünscht wird (nicht empfohlen)
    End Sub

    Private Sub ButtonTestBlzKto_Click(sender As Object, e As EventArgs) Handles ButtonTestBlzKto.Click
        Dim myRes As Integer
        Dim myResultText As String = ""
        Dim myBankName As String = ""
        Dim myNewBlz As String = ""
        Dim myIban As String = ""
        Dim myBic As String = ""
        myRes = KtoClient.TestBlzKto(TextBoxUN.Text, TextBoxPW.Text, TextBoxBlz.Text, TextBoxKto.Text, "", 0, "", myResultText, myBankName, myNewBlz, myIban, myBic)
        TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
        TextBoxRes.AppendText("Bankname: " & myBankName & vbCrLf)
        TextBoxRes.AppendText("IBAN: " & myIban & vbCrLf)
        TextBoxRes.AppendText("BIC: " & myBic & vbCrLf)
    End Sub

    Private Sub ButtonTestIbanBic_Click(sender As Object, e As EventArgs) Handles ButtonTestIbanBic.Click
        Dim myRes As Integer
        Dim myResultText As String = ""
        Dim myBankName As String = ""
        Dim myNewBlz As String = ""
        Dim myIbanOut As String = ""
        Dim myBic As String = ""
        Dim myBicName As String = ""
        Dim mySCT As Integer
        Dim mySDD As Integer
        Dim myB2B As Integer
        If TextBoxBic.Text = "" Then ' nur IBAN testen
            myRes = KtoClient.TestIban(TextBoxUN.Text, TextBoxPW.Text, TextBoxIban.Text, 0, "", myResultText, myBankName, myNewBlz, myIbanOut, myBic)
            TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
            TextBoxRes.AppendText("Bankname: " & myBankName & vbCrLf)
            TextBoxRes.AppendText("IBAN: " & myIbanOut & vbCrLf)
            TextBoxRes.AppendText("BIC: " & myBic & vbCrLf)
        Else ' nicht nur IBAN testen
            If TextBoxIban.Text = "" Then ' nur BIC testen
                myBicName = KtoClient.TestBic(TextBoxUN.Text, TextBoxPW.Text, TextBoxBic.Text, mySCT, mySDD, myB2B)
                TextBoxRes.AppendText("BicName: " & myBicName & vbCrLf)
                TextBoxRes.AppendText("SCT=" & mySCT.ToString & ", SDD=" & mySDD.ToString & ", B2B=" & myB2B.ToString & vbCrLf)
            Else ' IBAN und BIC testen
                myRes = KtoClient.TestIbanBic(TextBoxUN.Text, TextBoxPW.Text, TextBoxIban.Text, TextBoxBic.Text, 0, "", myResultText, myBankName, myBicName, myNewBlz, myIbanOut, myBic, mySCT, mySDD, myB2B)
                TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
                TextBoxRes.AppendText("Bankname: " & myBankName & vbCrLf)
                TextBoxRes.AppendText("IBAN: " & myIbanOut & vbCrLf)
                TextBoxRes.AppendText("BIC: " & myBic & vbCrLf)
                TextBoxRes.AppendText("BicName: " & myBicName & vbCrLf)
                TextBoxRes.AppendText("SCT=" & mySCT.ToString & ", SDD=" & mySDD.ToString & ", B2B=" & myB2B.ToString & vbCrLf)
            End If ' IBAN und BIC testen
        End If ' nicht nur IBAN testen
    End Sub

    Private Sub ButtonCc_Click(sender As Object, e As EventArgs) Handles ButtonCc.Click
        Dim myRes As Integer
        Dim myResultText As String = ""
        myRes = KtoClient.TestCc(TextBoxUN.Text, TextBoxPW.Text, TextBoxCc.Text, myResultText)
        TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
    End Sub

    Private Sub ButtonSearch_Click(sender As Object, e As EventArgs) Handles ButtonSearch.Click
        Dim myFragments As Integer
        Dim myBanken As String()
        Dim myCount As Integer
        If CheckBoxSearch.Checked Then
            myFragments = 1
        Else
            myFragments = 0
        End If
        myBanken = KtoClient.Search(TextBoxUN.Text, TextBoxPW.Text, TextBoxSearch.Text, "DE", myFragments)
        myCount = myBanken.Count
        TextBoxRes.AppendText("Anzahl: " & myCount.ToString & vbCrLf)
        For I = 0 To myCount - 1
            TextBoxRes.AppendText(myBanken(I) & vbCrLf)
        Next
    End Sub

    Private Sub ButtonAddress_Click(sender As Object, e As EventArgs) Handles ButtonAddress.Click
        ' Die Variante "Address" gibt die Ergebnisse als einzelne Variablen zurück.
        ' Die "Orte" sind ein Array of Strings,
        ' "AlteOrte" ein Array von Objekten mit den Feldern "Found", "AlterName" und "NeuerName"
        Dim myRes As Integer
        Dim myResultText As String = ""
        Dim myRewritten As String = ""
        Dim myStr46 As String = ""
        Dim myStr22 As String = ""
        Dim myOrtsteil As String = ""
        Dim myPlzOut As String = ""
        Dim myOrte As String() = New String() {} ' leeres Array anlegen
        Dim myAlteOrte As WebAddressS.TAlterOrt() = New WebAddressS.TAlterOrt() {} ' leeres Array anlegen
        Dim myCount As Integer

        If TextBoxOrt.Text = "" Then ' kein Ort angegeben: Typ der PLZ herausfinden
            myRes = AdrClient.GetPlzType(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, myResultText)
            TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
            If myRes > 100 Then ' gültige PLZ
                myRes = AdrClient.GetOrteOrtsteile(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, 2, myResultText, myOrte)
                TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
                myCount = myOrte.Count
                TextBoxRes.AppendText("Anzahl Orte: " & myCount.ToString & vbCrLf)
                For I = 0 To myCount - 1
                    TextBoxRes.AppendText(myOrte(I) & vbCrLf)
                Next
            End If ' gültige PLZ
        Else ' Ort angegeben
            If TextBoxStr.Text = "" Then ' keine Straße angegeben
                myRes = AdrClient.CheckPlzOrt(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, TextBoxOrt.Text, 2, myResultText, myRewritten, myOrte, myAlteOrte)
            Else ' also: Straße (und evtl. Hausnummer) angegeben
                myRes = AdrClient.CheckPlzOrtStr(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, TextBoxOrt.Text, TextBoxStr.Text, TextBoxHnr.Text, 2, myResultText, myRewritten,
                                                 myStr46, myStr22, myOrtsteil, myPlzOut, myOrte, myAlteOrte)
            End If
            TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
            TextBoxRes.AppendText("Rewritten: " & myRewritten & vbCrLf)
            TextBoxRes.AppendText("Str46: " & myStr46 & vbCrLf)
            TextBoxRes.AppendText("Str22: " & myStr22 & vbCrLf)
            TextBoxRes.AppendText("Ortsteil: " & myOrtsteil & vbCrLf)
            TextBoxRes.AppendText("PlzOut: " & myPlzOut & vbCrLf)
            myCount = myOrte.Count
            TextBoxRes.AppendText("Anzahl Orte: " & myCount.ToString & vbCrLf)
            For I = 0 To myCount - 1
                TextBoxRes.AppendText(myOrte(I) & vbCrLf)
            Next
            myCount = myAlteOrte.Count
            TextBoxRes.AppendText("Anzahl alte Orte: " & myCount.ToString & vbCrLf)
            For I = 0 To myCount - 1
                TextBoxRes.AppendText(myAlteOrte(I).AlterName & " heißt jetzt " & myAlteOrte(I).NeuerName & " (gefunden: " & myAlteOrte(I).Found.ToString & ")" & vbCrLf)
            Next
        End If ' Ort angegeben
    End Sub

    Private Sub ButtonAddress2_Click(sender As Object, e As EventArgs) Handles ButtonAddress2.Click
        ' Die Variante "Address2" gibt die Ergebnisse als ein einziges Objekt zurück.
        ' Die "Orte" sind ein Array of Strings,
        ' "AlteOrte" ein Array von Objekten mit den Feldern "Found", "AlterName" und "NeuerName"
        Dim myResObj As WebAddress2S.TAddressResult
        Dim myResInt As Integer
        Dim myResultText As String = ""
        Dim myOrteOrtsteile As String() = New String() {} ' leeres Array anlegen
        Dim myCount As Integer

        If TextBoxOrt.Text = "" Then ' kein Ort angegeben: Typ der PLZ herausfinden
            myResObj = Adr2Client.GetPlzType(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text)
            TextBoxRes.AppendText("Ergebnis: " & myResObj.Result.ToString & " (" & myResObj.ResultText & ")" & vbCrLf)
            If myResObj.Result > 100 Then ' gültige PLZ
                myResInt = Adr2Client.GetOrteOrtsteile(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, 2, myResultText, myOrteOrtsteile)
                TextBoxRes.AppendText("Ergebnis: " & myResInt.ToString & " (" & myResultText & ")" & vbCrLf)
                myCount = myOrteOrtsteile.Count
                TextBoxRes.AppendText("Anzahl Orte/Ortsteile: " & myCount.ToString & vbCrLf)
                For I = 0 To myCount - 1
                    TextBoxRes.AppendText(myOrteOrtsteile(I) & vbCrLf)
                Next
            End If ' gültige PLZ
        Else ' Ort angegeben
            If TextBoxStr.Text = "" Then ' keine Straße angegeben
                myResObj = Adr2Client.CheckPlzOrt(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, TextBoxOrt.Text, 2)
            Else ' also: Straße (und evtl. Hausnummer) angegeben
                myResObj = Adr2Client.CheckPlzOrtStr(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, TextBoxOrt.Text, TextBoxStr.Text, TextBoxHnr.Text, 2)
            End If
            TextBoxRes.AppendText("Ergebnis: " & myResObj.Result.ToString & " (" & myResObj.ResultText & ")" & vbCrLf)
            TextBoxRes.AppendText("Rewritten: " & myResObj.Rewritten & vbCrLf)
            TextBoxRes.AppendText("Str46: " & myResObj.Str46 & vbCrLf)
            TextBoxRes.AppendText("Str22: " & myResObj.Str22 & vbCrLf)
            TextBoxRes.AppendText("Ortsteil: " & myResObj.Ortsteil & vbCrLf)
            TextBoxRes.AppendText("PlzOut: " & myResObj.PlzOut & vbCrLf)
            myCount = myResObj.Orte.Count
            TextBoxRes.AppendText("Anzahl Orte: " & myCount.ToString & vbCrLf)
            For I = 0 To myCount - 1
                TextBoxRes.AppendText(myResObj.Orte(I) & vbCrLf)
            Next
            myCount = myResObj.AlteOrte.Count
            TextBoxRes.AppendText("Anzahl alte Orte: " & myCount.ToString & vbCrLf)
            For I = 0 To myCount - 1
                TextBoxRes.AppendText(myResObj.AlteOrte(I).AlterName & " heißt jetzt " & myResObj.AlteOrte(I).NeuerName & " (gefunden: " & myResObj.AlteOrte(I).Found.ToString & ")" & vbCrLf)
            Next
        End If ' Ort angegeben

    End Sub

    Private Sub ButtonAddress3_Click(sender As Object, e As EventArgs) Handles ButtonAddress3.Click
        ' Die Variante "Address" gibt die Ergebnisse als einzelne Variablen zurück.
        ' Sowohl "Orte" als auch "AlteOrte" sind ein Array of Strings.
        Dim myRes As Integer
        Dim myResultText As String = ""
        Dim myRewritten As String = ""
        Dim myStr46 As String = ""
        Dim myStr22 As String = ""
        Dim myOrtsteil As String = ""
        Dim myPlzOut As String = ""
        Dim myOrte As String() = New String() {} ' leeres Array anlegen
        Dim myAlteOrte As String() = New String() {} ' leeres Array anlegen
        Dim myCount As Integer
        Dim myAlterOrt As String()

        If TextBoxOrt.Text = "" Then ' kein Ort angegeben: Typ der PLZ herausfinden
            myRes = Adr3Client.GetPlzType(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, myResultText)
            TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
            If myRes > 100 Then ' gültige PLZ
                myRes = Adr3Client.GetOrteOrtsteile(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, 2, myResultText, myOrte)
                TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
                myCount = myOrte.Count
                TextBoxRes.AppendText("Anzahl Orte: " & myCount.ToString & vbCrLf)
                For I = 0 To myCount - 1
                    TextBoxRes.AppendText(myOrte(I) & vbCrLf)
                Next
            End If ' gültige PLZ
        Else ' Ort angegeben
            If TextBoxStr.Text = "" Then ' keine Straße angegeben
                myRes = Adr3Client.CheckPlzOrt(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, TextBoxOrt.Text, 2, myResultText, myRewritten, myOrte, myAlteOrte)
            Else ' also: Straße (und evtl. Hausnummer) angegeben
                myRes = Adr3Client.CheckPlzOrtStr(TextBoxUN.Text, TextBoxPW.Text, TextBoxPlz.Text, TextBoxOrt.Text, TextBoxStr.Text, TextBoxHnr.Text, 2, myResultText, myRewritten,
                                                  myStr46, myStr22, myOrtsteil, myPlzOut, myOrte, myAlteOrte)
            End If
            TextBoxRes.AppendText("Ergebnis: " & myRes.ToString & " (" & myResultText & ")" & vbCrLf)
            TextBoxRes.AppendText("Rewritten: " & myRewritten & vbCrLf)
            TextBoxRes.AppendText("Str46: " & myStr46 & vbCrLf)
            TextBoxRes.AppendText("Str22: " & myStr22 & vbCrLf)
            TextBoxRes.AppendText("Ortsteil: " & myOrtsteil & vbCrLf)
            TextBoxRes.AppendText("PlzOut: " & myPlzOut & vbCrLf)
            myCount = myOrte.Count
            TextBoxRes.AppendText("Anzahl Orte: " & myCount.ToString & vbCrLf)
            For I = 0 To myCount - 1
                TextBoxRes.AppendText(myOrte(I) & vbCrLf)
            Next
            myCount = myAlteOrte.Count
            TextBoxRes.AppendText("Anzahl alte Orte: " & myCount.ToString & vbCrLf)
            For I = 0 To myCount - 1
                myAlterOrt = Split(myAlteOrte(I), "|")
                TextBoxRes.AppendText(myAlterOrt(1) & " heißt jetzt " & myAlterOrt(2) & " (gefunden: " & (myAlterOrt(0) = "+").ToString & ")" & vbCrLf)
            Next
        End If ' Ort angegeben
    End Sub

End Class
